<template>
  <div id="_app">
    <!-- Navbar -->
    <Navbar/>

    <!-- Breadcrumb -->
    <Breadcrumb/>

    <div id="_app-content-view">
      <transition
        mode="out-in"
        enter-active-class="animated fadeIn _veryfast"
        leave-active-class="animated fadeOut _veryfast"
      >
        <router-view/>
      </transition>
    </div>

    <Footer></Footer>

    <!-- Extras -->
    <transition
      mode="in-out"
      enter-active-class="animated fadeIn _veryfast"
      leave-active-class="animated fadeOut _veryfast"
    >
      <MainLoading v-if="system.showMainLoading"/>
    </transition>

    <!-- Modals -->
    <RequiresVerifiedEmailModal v-model="showRequiresVerifiedEmailModal"/>
    <EmailSentModal v-model="showEmailSentModal"/>
    <PasswordGuardModal v-model="showPasswordGuardModal"/>
    <GlobalErrorModal v-model="showGlobalErrorModal"/>

  </div>
</template>

<script>
import Navbar from '@/components/partials/navbar/Navbar'
import Footer from '@/components/partials/footer/Footer'

import { mapState } from 'vuex'

export default {
  name: 'App',
  components: {
    Navbar,
    Footer
  },
  computed: {
    // Map state from root store
    ...mapState([
      'system'
    ]),
    /**
     * Magic computed for 'RequiresVerifiedEmailModal'
     */
    showRequiresVerifiedEmailModal: {
      get () { return this.system.modals.showRequiresVerifiedEmailModal },
      set (newValue) { this.$store.commit('SET_SYSTEM_SHOW_REQUIRES_VERIFIED_EMAIL_MODAL', newValue) }
    },
    /**
     * Magic computed for 'EmailSentModal'
     */
    showEmailSentModal: {
      get () { return this.system.modals.showEmailSentModal },
      set (newValue) { this.$store.commit('SET_SYSTEM_SHOW_EMAIL_SENT_MODAL', newValue) }
    },
    /**
     * Magic computed for 'PasswordGuardModal'
     */
    showPasswordGuardModal: {
      get () { return this.system.modals.showPasswordGuardModal },
      set (newValue) { this.$store.commit('SET_SYSTEM_SHOW_PASSWORD_GUARD_MODAL', newValue) }
    },
    /**
     * Magic computed for 'GlobalErrorModal'
     */
    showGlobalErrorModal: {
      get () { return this.system.modals.showErrorModal },
      set (newValue) { this.$store.commit('SET_SYSTEM_SHOW_ERROR_MODAL', newValue) }
    }
  },
  methods: {
    /**
     * updatePageTitle
     *
     * Update Page title (document.title)
     * @param {Object} to - The 'to' route
     * @param {Object} from - The 'from' route
     * @returns {void}
     */
    updatePageTitle: function (to, from) {
      // Default page title
      let pageTitle = this.$t('global.pageTitleSuffix')
      // If route.meta.pageMeta
      if (to.meta.pageMeta) {
        pageTitle = `${to.meta.pageMeta.title(this)} | ${this.$t('global.pageTitleSuffix')}`
      }
      // Update document.title
      document.title = pageTitle
    }
  },
  watch: {
    // Watch this.$route to dynamically update Page title (document.title)
    $route: 'updatePageTitle'
  },
  mounted () {
    // Update also at 'mounted' hook
    this.updatePageTitle(this.$route)
  }
}
</script>

<style lang="scss">
  // Include main.scss to the main 'app' component (root)
  @import "~#styles/main";

  #_app,
  #_app-content-view {
    min-height: 100vh;
  }
</style>
